/*
 * daemonize
 * run a program (commonly a shell script) as daemon
 * Frank Bergmann www.tuxad.com, 10/2007
 */

#define _GNU_SOURCE 1

#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/resource.h>
#include <sys/time.h>
#include <unistd.h>

/*

const char usage[]="usage: daemonize program [args]\n";

int str_len(const char* in) {
  register const char* t=in;
  for (;;) {
    if (!*t) break; ++t;
  }
  return (int)(t-in);
}

int str_diffn(const char* a, const char* b, unsigned long limit) {
  register const unsigned char* s=(const unsigned char*)a;
  register const unsigned char* t=(const unsigned char*)b;
  register const unsigned char* u=t+limit;
  register int j;
  j=0;
  for (;;) { if (t>=u) break; if ((j=(*s-*t))) break; if (!*t) break; ++s; ++t; }
  return j;
}
*/

int main(int argc,char *const argv[]) {
  pid_t pid;
/*
  struct rlimit l;

  if(getrlimit(RLIMIT_CORE, &l)==0) {
    l.rlim_cur=0;
    l.rlim_max=0;
    setrlimit(RLIMIT_CORE, &l);
  }
*/

/*
  if(argc==1) {
    write(2,usage,str_len(usage));
    _exit(127);
  }
*/
  /* if(str_diffn(argv[1],"clearenv",8)==0) { environ=0; argv++; } */
  if ((pid=fork())<0) {
    _exit(1);
  } else if (pid!=0) {
    _exit(0);
  }
/*
  if(str_diffn(argv[1],"nocd",4)) { chdir("/"); argv++; }
*/
  setsid();
  umask(0);
  chdir("/");
  close(0); close(1); close(2);
  execvp(argv[1],argv+1);
  _exit(2);
}
