#include <sys/types.h>
#include <sys/stat.h>
#include <utime.h>
#include <unistd.h>

/**
 * setfiletime.c
 * sets time of file/dir1 to time of file2
 */

int main(int argc, char *argv[]) {
  struct stat i_stat;
  struct utimbuf o_stat;

  if(stat(argv[2], &i_stat) == 0) {
    o_stat.actime = i_stat.st_atime;
    o_stat.modtime = i_stat.st_mtime;
    if(utime(argv[1], &o_stat) == 0) {
      _exit(0);
    } else {
      _exit(1);
    }
  } else {
    _exit(1);
  }
}
