/*
 * wav2raw.c v.0.0.2
 * drop wave header on 16-Bit audio input stream/ convert WAVE to
 * RAW (aka WAVE w/o wave-header) audio
 * compile with i.e.
 *   diet -Os gcc -Os -Wall -o wav2raw wav2raw.c; strip wav2raw
 * Frank Bergmann <something@tuxad.com>, 3/2006
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#define BUFSIZE 8192

int main() {
  char buf[BUFSIZE+1];
  register char *p;
  register ssize_t len;

  if(lseek(0,44,SEEK_SET)!=44) _exit(1);
  p = buf;
  for(;;) {
    len = read(0,p,BUFSIZE); if (len<1) break; write(1,p,len);
    len = read(0,p,BUFSIZE); if (len<1) break; write(1,p,len);
    len = read(0,p,BUFSIZE); if (len<1) break; write(1,p,len);
    len = read(0,p,BUFSIZE); if (len<1) break; write(1,p,len);
  }
  _exit(0);
}
