%debug_package %{nil}
%define _unpackaged_files_terminate_build 0
%define __os_install_post %{nil}

Summary: Some small tools
Name: fwb-tools
Version: 0.3.7
Release: 7
Source0: http://downloads.tuxad.de/fwb-tools/%{name}-%{version}.tar.gz
License: GPL v2
Group: Applications/Multimedia
URL: http://downloads.tuxad.de/fwb-tools/
BuildRoot: %{_tmppath}/buildroot-%{name}-%{version}

%description 	
Some small tools mostly for audio purposes:
cdr2wav, cdrdao2id3.py, cdrdao2wav.py, raw2352to2048, raw2352to2324,
raw2352to2336, raw2352tocdr2352, wav2raw
And for server/internet/general purpose:
ip_dotted2long, ip_long2dotted, lgrep, loghostip, showip,
logrockantennetitel, showrockantennetitel, setfiletime,
pycdcat.py, direntries, daemonize, sfgrep, filescan

%prep
%setup -q
rm -f OLDSTUFF_AND_ARCHIVE/tyrre*
tar xzf upx-2.02-src-stub-util-sstrip.tar.gz
patch -p0 <sstrip.c.diff
cp -af upx-2.02-src/src/stub/util/sstrip/sstrip.c src/

%build
make

%install
[ -d  ${RPM_BUILD_ROOT} -a "${RPM_BUILD_ROOT}" != "/" ] && rm -rf  ${RPM_BUILD_ROOT}
echo '*** JUST PRESS RETURN! ***'; read
%makeinstall -C src
make clean
rm -f src/*.1 src/*.py src/snmpd.conf src/Makefile || /bin/true
find ${RPM_BUILD_ROOT} . -name "nradm*" -o -name "tyrre*" |xargs rm -f

%clean
[ -d  ${RPM_BUILD_ROOT} -a "${RPM_BUILD_ROOT}" != "/" ] && rm -rf  ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root,-)
%doc README COPYING fwb-tools.spec src vdr-rockantenne-0.3.1.tgz
%_bindir/*
%_mandir/man1/*.1*

%changelog
* Sun Nov 23 2008 Frank Bergmann <http://www.tuxad.com/> 0.3.7.7
- small changes
- include filescan

* Wed Oct 29 2008 Frank Bergmann <http://www.tuxad.com/> 0.3.6-6
- remove nagios stuff, is now part of nagios-fwb
- update direntries
- include small sfgrep

* Sun Dec 30 2007 Frank Bergmann <http://www.tuxad.com/> 0.3.5-5
- rename nagios-check-backup-rsync to nagios-check-backup, small bugfix
- small Makefile changes

* Sun Dec 23 2007 Frank Bergmann <http://www.tuxad.com/> 0.3.4-4
- new: nagios-check-backup-rsync

* Wed Dec 19 2007 Frank Bergmann <http://www.tuxad.com/> 0.3.4-3
- new: sstrip-vladov
- define __os_install_post as NIL (to disable redhat's brp-strip)
- minor spec changes

* Wed Dec 19 2007 Frank Bergmann <http://www.tuxad.com/> 0.3.4-2
- new: nagios-check-nfs, nagios-check-kugelfisch, nagios-check-diskfree
- bugfix: logrockantennetitel/select also for read

* Sat Dec 15 2007 Frank Bergmann <http://www.tuxad.com/> 0.3.4-1
- new: postfix-mailqsize, daemonize assembler version

* Wed Nov 21 2007 Frank Bergmann <http://www.tuxad.com/> 0.3.3-1
- rockantenne 0.3.1
- new: direntries, daemonize and loadlogger

* Mon Jan 15 2007 Frank Bergmann <http://www.tuxad.com/> 0.3.1-1
- logrockantennetitel: small bugfix
- new version of vdr plugin vdr-rockantenne

* Mon Jan  8 2007 Frank Bergmann <http://www.tuxad.com/> 0.3.0-1
- logrockantennetitel: more exact recording of times
- include vdr plugin vdr-rockantenne in package

* Sun Jan  7 2007 Frank Bergmann <http://www.tuxad.com/> 0.2.3-1
- logrockantennetitel: more filtering of nonsense got from rockantenne.de

* Sun Jan  7 2007 Frank Bergmann <http://www.tuxad.com/> 0.2.2-1
- shorter request intervals on logrockantennetitel
- small time delay correction on logrockantennetitel

* Sat Jan  6 2007 Frank Bergmann <http://www.tuxad.com/> 0.2.1-1
- fix small bug in tyrre
- include tyrre.c in doc-dir
- new sstrip patch: correct bug fix shentsize, smaller code
- logrockantennetitel: some error output, don't log same title *after*
  news as *before* news

* Thu Oct 19 2006 Frank Bergmann <http://www.tuxad.com/> 0.2.0-1
- execute sstrip with patch after compile for smaller files

* Fri Oct 13  2006 Frank Bergmann <http://www.tuxad.com/> 0.1.10-1
- add some info to man-page setfiletime.1

* Mon Jun 26 2006 Frank Bergmann <http://www.tuxad.com/> 0.1.9-1
- fix small bug in utail.c
- increase ticket value in logrockantennetitel.c

* Thu Jun 22 2006 Frank Bergmann <http://www.tuxad.com/> 0.1.8-1
- include STRIP_ARGS in src/Makefile
- add utail.c

* Mon Jun 12 2006 Frank Bergmann <http://www.tuxad.com/> 0.1.7-2
- minor spec and Makefile changes

* Sun Jun 11 2006 Frank Bergmann <something@tuxad.com> 0.1.7-1
- include missing man-pages in Makefile
- include missing license file and spec file in docs
- add desc target in src/Makefile
- remove tyrre and nradm from binary package

* Sat Jun 10 2006 Frank Bergmann <something@tuxad.com> 0.1.6-1
- small changes in Makefile and spec-file

* Sat Jun 10 2006 Frank Bergmann <something@tuxad.com> 0.1.5-1
- include connect timeouts and log-all-titles in rockantenne apps

* Mon May 15 2006 Frank Bergmann <something@tuxad.com> 0.1.3-1
- fix local var bug and add ticket-count in logrockantennetitel.c

* Sun May 7 2006 Frank Bergmann <something@tuxad.com> 0.1.2-1
- more man-pages

* Fri May 5 2006 Frank Bergmann <something@tuxad.com> 0.1.1-1
- small changes in tyrre and showip, more man-pages

* Tue May 2 2006 Frank Bergmann <something@tuxad.com> 0.1.0-1
- initial build
